package com.sun.corba.se.impl.encoding;

import java.io.IOException;
import java.io.OutputStream;
import java.io.Serializable;
import org.omg.CORBA.Principal;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Object;
import org.omg.CORBA.portable.InputStream;

public interface MarshalOutputStream
{
    public abstract InputStream create_input_stream();
    
    public abstract void write_boolean(boolean p0);
    
    public abstract void write_char(char p0);
    
    public abstract void write_wchar(char p0);
    
    public abstract void write_octet(byte p0);
    
    public abstract void write_short(short p0);
    
    public abstract void write_ushort(short p0);
    
    public abstract void write_long(int p0);
    
    public abstract void write_ulong(int p0);
    
    public abstract void write_longlong(long p0);
    
    public abstract void write_ulonglong(long p0);
    
    public abstract void write_float(float p0);
    
    public abstract void write_double(double p0);
    
    public abstract void write_string(String p0);
    
    public abstract void write_wstring(String p0);
    
    public abstract void write_boolean_array(boolean[] p0, int p1, int p2);
    
    public abstract void write_char_array(char[] p0, int p1, int p2);
    
    public abstract void write_wchar_array(char[] p0, int p1, int p2);
    
    public abstract void write_octet_array(byte[] p0, int p1, int p2);
    
    public abstract void write_short_array(short[] p0, int p1, int p2);
    
    public abstract void write_ushort_array(short[] p0, int p1, int p2);
    
    public abstract void write_long_array(int[] p0, int p1, int p2);
    
    public abstract void write_ulong_array(int[] p0, int p1, int p2);
    
    public abstract void write_longlong_array(long[] p0, int p1, int p2);
    
    public abstract void write_ulonglong_array(long[] p0, int p1, int p2);
    
    public abstract void write_float_array(float[] p0, int p1, int p2);
    
    public abstract void write_double_array(double[] p0, int p1, int p2);
    
    public abstract void write_Object(org.omg.CORBA.Object p0);
    
    public abstract void write_TypeCode(TypeCode p0);
    
    public abstract void write_any(Any p0);
    
    public abstract void write_Principal(Principal p0);
    
    public abstract void write_value(Serializable p0);
    
    public abstract void start_block();
    
    public abstract void end_block();
    
    public abstract void putEndian();
    
    public abstract void writeTo(OutputStream p0) throws IOException;
    
    public abstract byte[] toByteArray();
}
